#include <SoftwareSerial.h>
#include <DFRobotDFPlayerMini.h>

#define pin_stop 7   // interrupteur raccroche
#define pin_pulse 8  // cadran
#define pin_df_tx 10 // dfPlayer TX
#define pin_df_rx 11 // dfPlayer RX

#define PULSE_LOW_DUR 5
#define PULSE_HIGH_DUR 5
#define PULSE_DELAY 100

unsigned long pulses_end;
int pulses;
bool pulse;
bool playing;
bool beeping;

SoftwareSerial dfSerial(pin_df_tx, pin_df_rx); // RX, TX
DFRobotDFPlayerMini dfPlayer;

void printDetail(uint8_t type, int value){
  if(type == DFPlayerPlayFinished)
    playing = false;
}

void setup() {
  pinMode(pin_stop, INPUT_PULLUP);
  pinMode(pin_pulse, INPUT_PULLUP);
  
  pulses_end = 0;
  pulses = 0;
  pulse = false;
  playing = false;
  beeping = false;

  dfSerial.begin(9600);
  dfPlayer.begin(dfSerial);
  
  dfPlayer.volume(15);
}

void loop() {
  if(digitalRead(pin_stop) == HIGH) {
    dfPlayer.stop();
    playing = false;
    beeping = false;
  }
  else if(!beeping) {
    dfPlayer.loop(11);
    beeping = true;
  }
  if(digitalRead(pin_pulse) == HIGH) {
    if(!pulse) {
      pulses ++;
      pulse = true;
    }
  }
  else if(pulse) {
    pulse = false;
    pulses_end = millis() + PULSE_DELAY;
  }
  else if(pulses) {
    if(millis() >= pulses_end) {
      dfPlayer.play(pulses);
      pulses = 0;
      playing = true;
    }
  }
  if(dfPlayer.available())
    printDetail(dfPlayer.readType(), dfPlayer.read());
  delay(1);
}
